property debug_me : false

property script_author : "Jonathan Nathan"
property script_name : "Consoler"
property script_version : "1.0.4"
property script_release_date : "January 31, 2007"
property script_copyright : " 2004, 2007 Jonathan Nathan. All Rights Reserved."

property script_url : "http://www.jonn8.com/"
property script_email : "mailto:Jonathan%20Nathan%20%3Cjonn8%40mac.com%3E?subject=Re:%20Consoler%20(v" & script_version & ")"
property script_contribution_url : "https://order.kagi.com/?ELJ"

property stop_log : false

property first_run : true
property run_plead : true
property command : ""
property previous_commands : {}
property the_setting_names : {"first_run", "run_plead", "command", "previous_commands"}

on will finish launching the_object
	set object_name to name of the_object as Unicode text
	my update_status("will finish launching " & object_name)
	my register_settings()
	my read_settings()
end will finish launching

on launched the_object
	my update_status("launched " & (name of the_object as Unicode text))
	activate
	show window "main"
	if first_run then display window "license" attached to window "main"
end launched

on should quit after last window closed the_object
	return true
end should quit after last window closed

on awake from nib the_object
	set object_name to name of the_object as Unicode text
	my update_status("awake from nib " & object_name)
	if object_name = "main" then
		tell the_object
			if first_run then center
			set contents of combo box "command" to command
			repeat with this_command in previous_commands
				call method "addItemWithObjectValue:" of combo box "command" with parameter (contents of this_command)
			end repeat
		end tell
		
	else if object_name = "about" then
		tell the_object
			tell box 1
				set contents of text field "title" to (script_name & " v" & script_version)
				set contents of text field "author" to ("by " & script_author)
				set contents of text field "release" to ("Released " & script_release_date)
				set contents of text field "copyright" to (script_copyright)
				set state of button "run_plead" to (run_plead as integer)
			end tell
		end tell
		
	end if
end awake from nib

on choose menu item the_object
	set object_name to name of the_object as Unicode text
	my update_status("choose menu item " & object_name)
	
	if object_name = "about" then
		display window "about" attached to window "main"
		
	else if object_name = "quit" then
		quit
		
	end if
end choose menu item

on clicked the_object
	set object_name to name of the_object as Unicode text
	my update_status("clicked " & object_name)
	
	if object_name = "decline" then
		close panel window "license"
		quit
		
	else if object_name = "accept" then
		set first_run to false
		my write_settings()
		close panel window "license"
		
	else if object_name = "dialog_cancel" then
		set the_win to name of window of the_object
		close panel window the_win
		
	else if object_name = "dialog_ok" then
		set the_win to name of window of the_object
		close panel window the_win
		
	else if object_name = "about_webpage" then
		open location script_url
		
	else if object_name = "about_email" then
		open location script_email
		
	else if object_name = "contribute" then
		open location script_contribution_url
		
	else if object_name = "run_plead" then
		set run_plead to (state of the_object = 1)
		my write_settings()
		
	else if object_name = "run" then
		my get_settings()
		set temp_file to (path to temporary items as Unicode text) & "tempout.txt"
		try
			if command contains "sudo" then
				set the_pid to do shell script command & " > " & (quoted form of POSIX path of temp_file) & " 2>&1 & echo $!" with administrator privileges
			else
				set the_pid to do shell script command & " > " & (quoted form of POSIX path of temp_file) & " 2>&1 & echo $!"
			end if
		on error the_error
			set contents of text view 1 of scroll view "log" of window "main" to the_error
			return
		end try
		set stop_log to false
		tell window "main"
			set contents of text field "status" to "Started PID " & the_pid
			set enabled of button "cancel" to true
			if (call method "objectValues" of combo box "command") does not contain command then call method "addItemWithObjectValue:" of combo box "command" with parameter command
		end tell
		--keep reloading while the process is alive:		
		repeat while ((count paragraphs of (do shell script "ps -p " & the_pid)) > 1)
			if stop_log then exit repeat
			delay 1
			my load_content(temp_file)
		end repeat
		set enabled of button "cancel" of window "main" to false
		if stop_log then
			try
				if command contains "sudo" then
					do shell script "kill -15 " & the_pid with administrator privileges
				else
					do shell script "kill -15 " & the_pid
				end if
			end try
			set contents of text field "status" of window "main" to "Cancelled PID " & the_pid
		end if
		--one last time for good measure
		my load_content(temp_file)
		set contents of text field "status" of window "main" to "Finished PID " & the_pid
		
	else if object_name = "clear" then
		tell window "main"
			set contents of text field "status" to ""
			set contents of text view 1 of scroll view "log" to ""
		end tell
		
	else if object_name = "cancel" then
		set stop_log to true
		
	end if
end clicked

on load_content(the_file)
	set the_content to read (the_file as alias)
	tell text view 1 of scroll view "log" of window "main"
		set content to the_content
		set the_length to (length of the_content)
		call method "scrollRangeToVisible:" of object it with parameter {the_length, the_length}
	end tell
end load_content

on close_all_panels()
	try
		set the_panels to windows whose class = panel and visible = true
		repeat with this_panel in the_panels
			try
				if name of this_panel  "main" then close panel this_panel
			on error
				close panel this_panel
			end try
		end repeat
	end try
end close_all_panels

on will open the_object
	try
		set {x, y} to (get size of window "main")
		set size of the_object to {x, y - 22}
	end try
	return true
end will open

on will quit the_object
	my quit_prep()
	return true
end will quit

on quit_prep()
	my close_all_panels()
	my get_settings()
	my write_settings()
	if run_plead then my plead()
	set quitting to true
end quit_prep

on assign_settings(the_settings)
	set {first_run, run_plead, command, previous_commands} to the_settings
end assign_settings

on get_settings()
	tell window "main"
		set command to contents of combo box "command"
		set previous_commands to call method "objectValues" of combo box "command"
	end tell
	return {first_run, run_plead, command, previous_commands}
end get_settings

on register_settings()
	set the_settings to my get_settings()
	tell user defaults
		repeat with i from 1 to (count the_setting_names)
			try
				make new default entry at end of default entries with properties {name:(item i of the_setting_names), contents:(item i of the_settings)}
			end try
		end repeat
		register
	end tell
end register_settings

on read_settings()
	set the_settings to {}
	tell user defaults
		repeat with i from 1 to (count the_setting_names)
			try
				set end of the_settings to contents of default entry (item i of the_setting_names)
			end try
		end repeat
	end tell
	my assign_settings(the_settings)
end read_settings

on write_settings()
	set the_settings to my get_settings()
	tell user defaults
		repeat with i from 1 to (count the_setting_names)
			try
				set contents of default entry (item i of the_setting_names) to (item i of the_settings)
			end try
		end repeat
	end tell
end write_settings

on update_status(the_message)
	if debug_me then log the_message
end update_status

on plead()
	tell application "System Events"
		activate
		set the_button to button returned of (display dialog "If you found this useful, and I hope you did, please consider contributing to my webhosting and general development costs. (You may disable this reminder in the About box.)" buttons {"Maybe Later", "Contribute Now"} default button 2 with icon 1)
	end tell
	if the_button = "Contribute Now" then open location script_contribution_url
end plead
